﻿using System.Collections.Generic;
using System.Linq.Expressions;
using Luticate2.Auth.Utils.Business.Converters.ExpressionConverter;
using Luticate2.Auth.Utils.Interfaces;

namespace Luticate2.Auth.Utils.Business.Converters
{
    public class LuConvertersOptions : ILuObjectConverterOptions, ILuObjectConverterDescriptorOptions,
        ILuExpressionConverterVisitorOptions, ILuExpressionParamReplaceVisitorOptions
    {
        public IDictionary<ParameterExpression, Expression> Parameters { get; set; }

        public ILuConvertersTypeConverter TypeConverter { get; set; }

        public ILuConvertersAllocator Allocator { get; set; }

        public ILuObjectConverterDescriptorOptions DescriptorOptions => this;

        public ILuExpressionParamReplaceVisitorOptions VisitorOptions => this;
    }
}