﻿using Luticate2.Auth.Auth.Dbo;
using Luticate2.Auth.Utils.Business.Pagination;
using Luticate2.Auth.Utils.Business.Utils;
using Luticate2.Auth.Utils.Dbo;
using Luticate2.Auth.Utils.Dbo.Result;
using Microsoft.CodeAnalysis.Scripting;
using Xunit;

namespace Luticate2.Auth.Tests.Business.Pagination
{
    public class LuFilterTests
    {
        [Fact]
        public void Test1()
        {
            var options = new LuExpressionUtils.LuExpressionParserOptions
            {
                ScriptOptions = ScriptOptions.Default.AddReferences(typeof(LuGroupDbo).Assembly)
            };
            var filterResult = LuFilterParser.Parse<LuGroupDbo>("x.Name.Contains(\"test\")", options);
            Assert.Equal(LuStatus.Success.ToInt(), filterResult.Status);
            Assert.NotNull(filterResult.Data);
        }
    }
}